设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 96|回复: 24

[API建议] xdrx_drag_jig建议

[复制链接]

签到天数: 111 天

连续签到: 1 天

[LV.6]常住居民II

已领礼包: 56个

财富等级: 招财进宝

发表于 2017-8-13 13:25:50 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
本帖最后由 brainstorm 于 2017-8-13 13:27 编辑

如下图,采用TT1方式,xdrx_drag_jig在鼠标停止运动时,图面上不显示拖动的图元
tt1.gif
代码如下
(defun c:tt1 (/ E P1 dragtext)
  (vl-acad-defun 'dragtext)
  (defun dragtext (p) (xdrx_modent 10 p) (entupd e))
  (setq p1 (getvar "lastpoint"))
  (while (setq e (car (entsel)))
    (xdrx_setenttodb e)
    (xdrx_drag_jig "dragtext" "选择文字插入点:" "" (+ 128 2048) 0 p1)
  )
)

如下图,采用TT2方式(dyndraw是网上找的另一个函数),则能够始终显示拖动的图元
tt2.gif
代码如下:
(defun c:tt2 (/ E P1 dragtext)
  (vl-acad-defun 'dragtext)
  (defun dragtext (p) (xdrx_modent 10 p) (entupd e))
  (setq p1 (getvar "lastpoint"))
  (while (setq e (car (entsel)))
    (dyndraw e)
    (dyndraw "dragtext" "选择文字插入点:" "" (+ 128 2048) 0 p1)
    (entupd e)
  )
)


建议能够始终显示拖动的图元



上一篇:拖动过程如何避免闪烁
下一篇:Modent 和setpropertyvalue 对于属性块操作疑问

评分

参与人数 1D豆 +10 收起 理由
XDSoft + 10 热心帮忙奖!

查看全部评分

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复
百度谷歌雅虎搜狗搜搜有道360奇虎

使用道具 举报

签到天数: 334 天

连续签到: 2 天

[LV.8]以坛为家I

已领礼包: 51个

财富等级: 招财进宝

发表于 2017-8-13 13:34:18 | 显示全部楼层
可以用下面的替代,先

  1. (XD::Drag:SimpleMove (ssget) "\n第二点<退出>:" 5 t)

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 111 天

连续签到: 1 天

[LV.6]常住居民II

已领礼包: 56个

财富等级: 招财进宝

 楼主| 发表于 2017-8-13 13:48:44 | 显示全部楼层

忘了补充说明一下,这个不是cad的文字图元,是自定义对象内部的文字,现在是只想拖动这个文字,而不改变整个自定义对象的位置。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 334 天

连续签到: 2 天

[LV.8]以坛为家I

已领礼包: 51个

财富等级: 招财进宝

发表于 2017-8-13 13:51:01 | 显示全部楼层

你附件传上个图来,我看看。拖动函数还有个  xd::drag:gmove  这个支持自定义的回调函数,你在回调函数做你修改自定义对象的事。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 111 天

连续签到: 1 天

[LV.6]常住居民II

已领礼包: 56个

财富等级: 招财进宝

 楼主| 发表于 2017-8-13 13:52:41 | 显示全部楼层
如下图一样的自定义对象
tt4.gif
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 111 天

连续签到: 1 天

[LV.6]常住居民II

已领礼包: 56个

财富等级: 招财进宝

 楼主| 发表于 2017-8-13 13:57:40 | 显示全部楼层
请点击此处下载

查看状态:需购买或无权限

您的用户组是:游客

文件名称:Drawing1.rar  备注: 
下载次数:0  文件大小:30.54 KB 
下载权限: 不限 以上  [免费赚D豆]


附件是cad图纸 是斯维尔画的 斯维尔是免费的 可以下载到
否则可能无法编辑
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 334 天

连续签到: 2 天

[LV.8]以坛为家I

已领礼包: 51个

财富等级: 招财进宝

发表于 2017-8-13 14:01:47 | 显示全部楼层

修改下你的代码,你试试

  1. (defun c:tt1 (/ E P1 dragtext)
  2.   (vl-acad-defun 'dragtext)
  3.   (defun dragtext (p) (xdrx_modent 10 p) (entupd e))
  4.   (xdrx_sysvar_push '("othromode" 0))
  5.   (while (setq e (car (entsel)))
  6.     (xdrx_setenttodb e)
  7.     (setq basePnt (xdrx_getentdxf 10))
  8.     (XD::Drag:GMove basePnt "选择文字插入点:" 0 nil t "dragtext")
  9.   )
  10.   (xdrx_sysvar_pop)
  11. )


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 111 天

连续签到: 1 天

[LV.6]常住居民II

已领礼包: 56个

财富等级: 招财进宝

 楼主| 发表于 2017-8-13 15:41:13 | 显示全部楼层
其实拿最简单的矩形试一下就知道,效果如下图
tt5.gif
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 111 天

连续签到: 1 天

[LV.6]常住居民II

已领礼包: 56个

财富等级: 招财进宝

 楼主| 发表于 2017-8-13 20:34:29 | 显示全部楼层
本帖最后由 brainstorm 于 2017-8-13 20:36 编辑
  1. (defun c:tt (/ e p)
  2.   (vl-acad-defun
  3.     'dragtext
  4.   )
  5.   (defun dragtext (p)
  6.     (xdrx_modent 10 p)
  7.   )
  8.   (while
  9.     (setq e (car (entsel)))
  10.      (xdrx_setenttodb e)
  11.      (xdrx_pointmonitor "dragtext")
  12.      (getpoint)
  13.      (xdrx_pointmonitor)
  14.   )
  15. )

用xdrx_pointmonitor就可以了。
比较一下drag_jig和pointmonitor
drag_jig在拖动曲线顶点时需要entupd,同时忽略对曲线自身捕捉的设置
pointmonitor在拖动曲线顶点时无需entupd,能够捕捉曲线自身,但屏幕上有事会留下捕捉的标记
感觉jig拖动起来更流畅一些
能把几个函数的有点综合一下么
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 111 天

连续签到: 1 天

[LV.6]常住居民II

已领礼包: 56个

财富等级: 招财进宝

 楼主| 发表于 2017-8-13 20:42:16 | 显示全部楼层
tt6.gif


上图留下绿色的标记,API版本0808的
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 586 天

连续签到: 2 天

[LV.9]以坛为家II

已领礼包: 18个

财富等级: 恭喜发财

发表于 2017-8-13 21:33:49 | 显示全部楼层

标记你可以通过系统变量去关闭,那些是跟踪什么的
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 890 天

连续签到: 10 天

[LV.10]以坛为家III

已领礼包: 39个

财富等级: 招财进宝

发表于 2017-8-14 08:47:36 | 显示全部楼层

关闭对象追踪。。。就没标记了

改下你的代码

  1. (defun c:tt (/ e p)
  2.   (vl-acad-defun
  3.     'dragtext
  4.   )
  5.   (defun dragtext (p)
  6.     (xdrx_modent 10 p)
  7.   )
  8.   (xdrx_sysvar_push '("orthomode" 0 "autosnap" 0))
  9.   (while
  10.     (setq e (car (entsel)))
  11.      (xdrx_setenttodb e)
  12.      (xdrx_pointmonitor "dragtext")
  13.      (getpoint)
  14.      (xdrx_pointmonitor)
  15.   )
  16.   (xdrx_sysvar_pop)
  17. )



论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 111 天

连续签到: 1 天

[LV.6]常住居民II

已领礼包: 56个

财富等级: 招财进宝

 楼主| 发表于 2017-8-14 09:21:34 | 显示全部楼层
  1. (xdrx_sysvar_push '("orthomode") '( "autosnap" 55))
复制代码

设成55还能捕捉,只不过需要按一下shift键
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 890 天

连续签到: 10 天

[LV.10]以坛为家III

已领礼包: 39个

财富等级: 招财进宝

发表于 2017-8-14 09:28:24 | 显示全部楼层

根据你自己的需要设置吧。

另外,你为什么没试上面那个  xd::drag:gmove 的,他能根据你的需要只在X轴,或只在Y轴,或X,Y两个轴上 拖动。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 1164 天

连续签到: 1 天

[LV.10]以坛为家III

点击这里给我发消息

已领礼包: 142个

财富等级: 日进斗金

发表于 2017-8-14 14:41:26 | 显示全部楼层
谢谢,下版本更新。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|Archiver|手机版|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

辽公网安备 21040202000005号

GMT+8, 2018-1-16 23:30 , Processed in 0.522041 second(s), 132 queries , Gzip On.

Powered by Discuz! X3.2

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表